;--------------------------------------------------------------------------------------------
;BlitzAvi Helper Function Library (c) StudioX64 2003
;--------------------------------------------------------------------------------------------
;
;Bank Information
;--------------------------------------------------------------------------------------------
;0-79    bytes inc = FileName of output Avi file.                       (chars = 1 byte each)
;80-83   bytes inc = Time of each frame in the movie.                   (int's = 4 bytes)
;84-163  bytes inc = FileName of image to render to the avi file        (chars = 1 byte each)
;164-239 bytes inc = Handle Of Window (AppTitle)                        (chars = 1 byte each)
;
;240     bytes inc = Use compression (DIVX etc) - asked for at runtime  (chars = 1 byte each)
;                    only works in windowed mode, will crash full screen mode!!!!!
;
;241     bytes inc = Suppress message about overwriting file, with this (chars = 1 byte each)
;                    flag set to true will just overwrite the AVIm use
;                    this with caution!
;--------------------------------------------------------------------------------------------
;
;Variables used by these functions are as follows: 
;** You should avoid using any of these variables in your applications **
;--------------------------------------------------------------------------------------------
;baviBankSize
;baviBankDataIn
;baviBankDataOut
;baviApplicationTitle$
;baviNameOfAviFiles$
;baviFrameTime
;baviImageName$
;baviCompressionFlag
;baviSuppressOverwrite
;baviDLLName
;--------------------------------------------------------------------------------------------
;
;Program relies upon the DLL being called "BlitzAvi.dll" and being located in your application directory.
;If you have to change the DLL name for some reason, then change the name of the next global.
;
Global baviDLLName$ = "BlitzAvi" ;If you have to rename the DLL then change this.
;
;--------------------------------------------------------------------------------------------


Function CreateAviFile(baviApplicationTitle$, baviNameOfAviFile$, baviFrameTime, baviImageName$, baviCompressionFlag, baviSuppressOverwrite)
	baviBankSize = 250

	baviBankDataIn  = CreateBank(baviBankSize)
	baviBankDataOut = CreateBank(baviBankSize)

	For tcount = 0 To baviBankSize-1
		PokeByte baviBankDataIn, tcount, 0
		PokeByte baviBankDataOut, tcount, 0
	Next

	If Len(baviNameOfAviFile$) > 80 Then RuntimeError "Name Of Avi File is too long, must be 80 characters or less!"

	For tcount = 0 To Len(baviNameOfAviFile$)-1
		PokeByte baviBankDataIn, tcount, Asc(Mid$(baviNameOfAviFile$, tcount+1, 1))
	Next
	
	PokeInt baviBankDataIn, 80, baviFrameTime
	
	;don't ask about this, minor miscalculation on my part :) should have been 80 but I am too lazy to change!!!
	If Len(baviImageName$) > 79 Then RuntimeError "Name Of Image Bitmap to render to AVI, must be 79 characters or less!"
	
	For tcount = 0 To Len(baviImageName$)-1
		PokeByte baviBankDataIn, tcount+84, Asc(Mid$(baviImageName$, tcount+1, 1))
	Next	
	
	If Len(baviApplicationTitle$) > 75 Then RuntimeError "Your application title 'AppTitle' must be 75 characters or less!"

	For tcount = 0 To Len(baviApplicationTitle$)-1
		PokeByte baviBankDataIn, tcount+164, Asc(Mid$(baviApplicationTitle$, tcount+1, 1))
	Next
		
	If baviCompressionFlag = False Then
		PokeByte baviBankDataIn, 240, False
	Else
		PokeByte baviBankDataIn, 240, True
	End If
	
	If baviSuppressOverwrite = False Then
		PokeByte baviBankDataIn, 241, False
	Else
		PokeByte baviBankDataIn, 241, True
	End If	
	
	result = CallDLL("BlitzAvi","create_avi_file", baviBankDataIn, baviBankDataOut) ;test purposes only!!
	
	Return result
End Function


;----------------------------------------------------------------------------------------------------------------------------------

Function WriteImageToAviFile()
	result = CallDLL(baviDLLName$, "write_image_to_avi_file")
	Return result
End Function


;----------------------------------------------------------------------------------------------------------------------------------

Function CloseAviFile()
	FreeBank baviBankDataIn
	FreeBank baviBankDataOut
	result = CallDLL(baviDLLName$, "close_avi_file")
	Return result
End Function

;----------------------------------------------------------------------------------------------------------------------------------