;----------------------------------------------------------------------------
; This example was from the BlitzBasic.com website, it can be found:
; http://www.blitzbasic.com/user/showuser.php?id=1981 
; It was posted by -NORC-
;
; StudioX64 have modified only slightly to include calls to the BlitzAvi.DLL
; functions needed to create a running movie with compression.
; For more help on the BlitzAvi.DLL functions please read the DLL
; documentation.  Please also pay special care to the license agreement.
; If you are going to use compression, you MUST run in a window.
; Below follows the original text from this source code.
;
; This is the Original Source for many of my Plasma-FX.
; Original QB-Plasma, ported to BB . By CSP 2001.
;
; Note: Turn Off the Debugger, or it will be way too slow
;----------------------------------------------------------------------------


Graphics 320,240,16,2 ;Set a small windowed graphics mode.

Include "BlitzAvi.inc" ;include the BlitzAvi helper function library.

MyAppTitle$ = "Blitz Plasma App" ;You must pass the name of the window handle (or Application title)
                                 ;to the BlitzAvi.DLL.  This is the easiest way I found
                                 ;of doing this.

AppTitle MyAppTitle$ ;Title you application as defined by MyAppTitle.

result = CreateAviFile(MyAppTitle$, "example.avi", 30, "output.bmp", True, False) ;Call to BlitzAvi
;helper function library (included at the top of the code).  result is the return code, 0=bad, 1=good!
;The function creates an open file on your hard disk, and sets some initial parameters.  

;First parameter is the application title (AppTitle) this is why we use a string instead of simply
;assigning AppTitle a title, this allows us to pass the string to the DLL as a window handle.

;Second parameter is the name of the AVI file to create.

;Third parameter is the time a frame will display for before going to the next (in clock ticks).
;Setting To 33 gives us a speed similar To TV, eg, 30 frames a second.  If you wanted Each image To 
;display for a second you would use 1000 as frame speed.

;Forth parameter is the name of the file on your hard drive you will use to render each frame to
;the AVI.  This is a constant name which the function WriteImageToAviFile will use when rendering
;the image to the AVI.  It is the name which you give to the SaveBuffer command as a filename
;when you capture the screen.

;Fifth parameter is the compression flag.  If this is set to false then a standard windows AVI
;file will be created without any prompting aside from file exists overwrite messages.  (these
;can be turned off using the next parameter)  If this is true then when you call WriteImageToAviFile
;for the first time a windows dialog box will appear (this is the reason you can not run compressed
;files in full screen mode).  You can choose from the dialog box the type of compression codec you
;require.  This will include all of those currently installed on your computer, if you have DIVX
;installed then from here you should be able to choose it.  You will only be asked for the 
;compression type on the first frame.  All others will continue to use this compression.

;Sixth parameter is suppress overwrite file messages flag.  If you try and create an avi file
;that already exists on your hard drive, a message window will appear prompting you to overwrite
;the file yes / no.  If this flag is set to true then these messages will no longer appear, hence
;suppression of messages is true.

SetBuffer BackBuffer()

plasma = CreateImage(320, 240)
Dim cosinus(640)
position = 0

For c = 0 To 640
	cosinus(c) = Cos((115*3.14159265358 * c) / 320) * 32 + 32
Next
 
;Create some Color Arrays

Dim r(255) : Dim g(255) : Dim b(255) : Dim mrgb(255)

For i=0 To 63 : r(i)=i*4 : g(i)=0 : b(i)=255-(i*4) : Next
For i=0 To 63 : r(i+64)=255-(i*4) : g(i+64)=i*2 : b(i+64)=0 : Next
For i=0 To 63 : r(i+128)=i*2 : g(i+128)=128-(i*2) : b(i+128)=i*4 : Next
For i=0 To 63 : r(i+192)=128+(i*2) : g(i+192)=i : b(i+192)=255-(i*4) : Next
For i=0 To 255 : mrgb(i)=((r(i)*$10000)+(g(i)*$100)+b(i))And $FFFFFF : Next

;Main Loop

While a<>27
	a=GetKey() ;Wait around for a key to be pressed
	Gosub qbplasma
	Flip
	
	SaveBuffer(BackBuffer(),"output.bmp") ;This is the important part, you must capture
	;the screen after each drawn frame to the filename which you specified in parameter 4
	;of the CreateAviFile call earlier.  Failure to write this file will cause the next
	;function to fail.
	
	result = WriteImageToAviFile() ;This renders the image saved in the previous function
	;call to your AVI file.  The result codes are 0=bad, 1=good!
	
Wend

result = CloseAviFile() ;This is a very important call to close the AVI file, once you have
;finished writing your images to it.  Failure to do so will result in an unusable file, probably
;zero bytes in length.

End

.qbplasma
wave1 = wave1 + 2
If wave1 >= 320 Then wave1 = 0 
wave2 = wave2 + 2
If wave2 >= 320 Then wave2 = 0
wave3 = wave3 + 3
If wave3 >= 320 Then wave3 = 0
SetBuffer ImageBuffer(plasma)
LockBuffer
For y = 0 To 319
	d = cosinus(y + wave2) + cosinus(y + wave3)
   	For x = 0 To 319
    	f = (cosinus(x + wave1) + cosinus(x + y) + d) And $FF
    	WritePixelFast x,y,mrgb(f)
  	Next 
Next
UnlockBuffer
SetBuffer BackBuffer()
DrawImage plasma,0,0
Return